#!/usr/bin/python3
import socket
import subprocess
import time
import sys

# global definitions
DEBUG = True
SERVER_IP = '192.168.99.1'
SERVER_PORT = 10002

# function
def start_video_client(robot_ip,robot_port):
    total_data_recv = 0
    PKT_SIZE = 1024
    cmdline = ['mplayer','-fps','40', '-xy', '800','-msglevel','all=-1','-cache','256','-']  
    if DEBUG: print("[MSG]> start_video_client()")  
       
    try:
        client_socket = socket.socket()
        client_socket.connect((robot_ip,robot_port))
        if DEBUG: print("[MSG]> success: connected to {}:{}".format(robot_ip,robot_port))
    except Exception as e:
        if DEBUG: print("[MSG]> error: {}".format(str(e)))
        if DEBUG: print("[MSG]> error: not connected to {}:{}".format(robot_ip,robot_port))
    try:
        player = subprocess.Popen(cmdline, stdin=subprocess.PIPE, stderr=subprocess.PIPE)
        while True:
            data = client_socket.recv(PKT_SIZE)
            if not data: 
                if DEBUG: print('[MSG]> error: connection closed')
                break
            total_data_recv += len(data)
            print("[MSG]> {} bytes received".format(total_data_recv))
            player.stdin.write(data)
    except Exception as e:
        print("[MSG]> error: {}".format(str(e)))
    finally:
        player.terminate()       
        client_socket.close()   
        time.sleep(1)
        if DEBUG: print("[MSG]> video channel closed")     
        
# main
if __name__ == "__main__":
    try:
        start_video_client(SERVER_IP, SERVER_PORT)
    except KeyboardInterrupt:
        if DEBUG: print("[MSG]> Ctrl-C detected ... exiting"); sys.exit()
